{Lathe feed drive automation controller}
{
Revision V100
}
CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000
        SCL = 0                                         'LCD SCL Pin
        SDA = 1                                         'LCD SDA Pin
        LCD_ADDR = %111                                 'PCF8574 address
        DirPin = 2
        PulsPin = 3
        LftBttn = 4
        RghtBttn = 5
        MdeSelect = 6
        

VAR
  long Stackspc[512]
  word Page,Speed,Speedfrq
  byte Left_button,Right_button,ModeSelect                                                              'Buttons
  
   
OBJ
    Fl  : "float32.spin"
    Encoder : "Quadrature Encoder.spin"
    I2C : "Basic_I2C_Driver_1"
    Time: "jm_time"
    LCD: "jm_lcd_pcf8574"
    Synth: "Synth"
    
  
PUB Main
  speed := 22
  Initialise                                            'Run initialisation routines
  cognew(MotorControl,@StackSpc)                        'Starts motocontrol in seperate cog
       repeat
         updatedisplay
         ReadInputs
PUB UpdateDisplay
    Case Page
      0:        
        LCD.move_cursor(0,0)
        LCD.Str(string("Async Control"))
        LCD.move_cursor(0,1)
        LCD.dec(Speed)        
        lcd.str(string("mm/sec    "))
        if speed>200
          speed~
      1:
PUB ReadInputs
    Left_button := Ina[lftBttn]
    Right_Button := Ina[RghtBttn]
    If Left_button                                      'Left Button cancels Right Button 
      Right_Button~
    ModeSelect := Ina[MdeSelect]
     
PUB Initialise                  'Initiates code/driver/lcd/etc
  Dira[LftBttn]~                'Set Inputs
  Dira[RghtBttn]~
  Dira[MdeSelect]~               
  
                                                                                
  Time.start                                            'config time delays
  LCD.start(SCL, SDA, LCD_ADDR)                         'Start LCD
  LcdSplash                                             'Splash screen
PUB LcdSplash                   'LCD Splash screen

  LCD.clear
  LCD.move_cursor(0,0)
  LCD.Str(string("   Lathe Feed   "))
  LCD.move_cursor(0,1)
  LCD.str(string("  Control V100  "))
  time.pause(2500)
  LCD.clear
PUB MotorControl
'init script
  Dira[DirPin]~~                'Set output
  Dira[pulsPin]~~


'main script
repeat
  If Not ModeSelect             'Mode 0 Async / Mode 1 Sync
    if Left_Button
      Outa[DirPin] := 1         'Sets Direction
      SpeedtoFrq                'Converts Speed(mm/sec) to calibrated frequency
      Synth.Synth("A",PulsPin,20_000)
    if Right_Button
    IF not Right_Button & Left_Button
      Synth.Synth("A",PulsPin,0)

  else


      
      
     
  

Pub SpeedtoFrq
  '(MM/S)*(Step per rev)*usteprate
  Speedfrq := speed * 1600   
    
            